25개 이상의 토픽을 선택하실 수 없습니다. Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

356 lines
13 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
  7. exit
  8. }
  9. prefix="/usr/local"
  10. pass_prefix="mw-"
  11. muttdir="${XDG_CONFIG_HOME:-$HOME/.config}/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="${XDG_DATA_HOME:-$HOME/.local/share}/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".+@.+\..+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="${MBSYNCRC:-$HOME/.mbsyncrc}"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="${XDG_CACHE_HOME:-$HOME/.cache}/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="${XDG_CONFIG_HOME:-$HOME/.config}/msmtp/config"
  22. msmtplog="${XDG_CONFIG_HOME:-$HOME/.config}/msmtp/msmtp.log"
  23. MARKER="# mw-autogenerated"
  24. alias mbsync='mbsync -c "$mbsyncrc"'
  25. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  26. do
  27. [ -f "$x" ] && sslcert="$x" && break
  28. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  29. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\.muttrc$//" | sort -n)" ;}
  30. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  31. getprofiles() { \
  32. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  33. msmtp_header="defaults
  34. auth on
  35. tls on
  36. tls_trust_file $sslcert
  37. logfile $msmtplog
  38. "
  39. msmtp_profile="account $fulladdr
  40. host $smtp
  41. port ${sport:-587}
  42. from $fulladdr
  43. user $login
  44. passwordeval \"pass $pass_prefix$fulladdr\"
  45. $starttlsoff
  46. "
  47. mbsync_profile="IMAPStore $fulladdr-remote
  48. Host $imap
  49. Port ${iport:-993}
  50. User $login
  51. PassCmd \"pass $pass_prefix$fulladdr\"
  52. AuthMechs LOGIN
  53. SSLType ${ssltype:-IMAPS}
  54. CertificateFile $sslcert
  55. MaildirStore $fulladdr-local
  56. Subfolders Verbatim
  57. Path ${XDG_DATA_HOME:-$HOME/.local/share}/mail/$fulladdr/
  58. Inbox ${XDG_DATA_HOME:-$HOME/.local/share}/mail/$fulladdr/INBOX
  59. Flatten .
  60. Channel $fulladdr
  61. Expunge Both
  62. Master :$fulladdr-remote:
  63. Slave :$fulladdr-local:
  64. Patterns * !\"[Gmail]/All Mail\"
  65. Create Both
  66. SyncState *
  67. MaxMessages ${maxmes:-0}
  68. ExpireUnread no
  69. # End profile
  70. "
  71. if [ -z "${online+x}" ]; then
  72. mutt_profile="# vim: filetype=neomuttrc
  73. # muttrc file for account $fulladdr
  74. set realname = \"$realname\"
  75. set from = \"$fulladdr\"
  76. set sendmail = \"msmtp -a $fulladdr\"
  77. alias me $realname <$fulladdr>
  78. set folder = \"$maildir/$fulladdr\"
  79. set header_cache = $cachedir/$fulladdr/headers
  80. set message_cachedir = $cachedir/$fulladdr/bodies
  81. set mbox_type = Maildir
  82. bind index,pager gg noop
  83. bind index,pager g noop
  84. bind index,pager M noop
  85. bind index,pager C noop
  86. bind index gg first-entry
  87. macro index o \"<shell-escape>mw -y $fulladdr<enter>\" \"run mbsync to sync $fulladdr\"
  88. unmailboxes *
  89. "
  90. else
  91. mutt_profile="# vim: filetype=neomuttrc
  92. # muttrc file for account $fulladdr
  93. set realname = \"$realname\"
  94. set from = \"$fulladdr\"
  95. set sendmail = \"msmtp -a $fulladdr\"
  96. alias me $realname <$fulladdr>
  97. set folder = \"imaps://$login@$imap:${iport:-993}\"
  98. set imap_user = \"$login\"
  99. set header_cache = $cachedir/$fulladdr/headers
  100. set message_cachedir = $cachedir/$fulladdr/bodies
  101. set imap_pass = \"\`pass $pass_prefix$fulladdr\`\"
  102. set mbox_type = Maildir
  103. set ssl_starttls = yes
  104. set ssl_force_tls = yes
  105. bind index,pager gg noop
  106. bind index,pager g noop
  107. bind index,pager M noop
  108. bind index,pager C noop
  109. bind index gg first-entry
  110. unmailboxes *
  111. "
  112. fi
  113. printf "DONE.\\n"
  114. }
  115. parsedomains(){ serverinfo="$(grep "^${fulladdr#*@}" "$muttshare/domains.csv" 2>/dev/null)"
  116. [ -z "$serverinfo" ] && serverinfo="$(grep "$(echo "${fulladdr#*@}" | sed "s/\.[^\.]*$/\.\\\*/")" "$muttshare/domains.csv" 2>/dev/null)"
  117. IFS=, read -r service imapsugg iportsugg smtpsugg sportsugg <<EOF
  118. $serverinfo
  119. EOF
  120. imap="${imap:-$imapsugg}"
  121. smtp="${smtp:-$smtpsugg}"
  122. sport="${sport:-$sportsugg}"
  123. iport="${iport:-$iportsugg}"
  124. }
  125. delete() { if [ -z "${fulladdr+x}" ]; then
  126. echo "Select the account your would like to delete (by number):"
  127. list
  128. read -r input
  129. match="^$input:"
  130. else
  131. match=" $fulladdr$"
  132. getaccounts
  133. fi
  134. fulladdr="$(echo "$accounts" | grep "$match" | cut -f2 -d' ')"
  135. [ -z "$fulladdr" ] && echo "Invalid account name given." && return 1
  136. sed -ibu "/IMAPStore $fulladdr-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  137. rm -rf "${cachedir:?}/${fulladdr:?}" "$accdir/"[1-9]"-$fulladdr.muttrc"
  138. sed -ibu "/[0-9]-$fulladdr.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  139. sed -ibu "/account $fulladdr/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  140. }
  141. askinfo() { \
  142. [ -z "$fulladdr" ] && echo "Give the full email address to add:" &&
  143. read -r fulladdr
  144. while ! echo "$fulladdr" | grep -qE "$emailre"; do
  145. echo "\`$fulladdr\` is not a valid email address. Please retype the address:"
  146. read -r fulladdr
  147. done
  148. { [ -z "$imap" ] || [ -z "$smtp" ] ;} && parsedomains
  149. [ -z "$imap" ] && echo "Give your email server's IMAP address (excluding the port number):" &&
  150. read -r imap
  151. [ -z "$smtp" ] && echo "Give your email server's SMTP address (excluding the port number):" &&
  152. read -r smtp
  153. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  154. [ -z "$realname" ] && echo "Give the name you would like to be identified by on the email account:" &&
  155. read -r realname
  156. login="${login:-$fulladdr}"
  157. getpass
  158. }
  159. writeinfo() { mkdir -p "$muttdir" "$accdir" "$cachedir/$fulladdr/bodies" "${XDG_CONFIG_HOME:-$HOME/.config}/msmtp" "$maildir/$fulladdr"
  160. # Get accounts and find the first missing account number (max. 9).
  161. getaccounts; for x in $(seq 1 9); do echo "$accounts" | grep -q "$x" || { export idnum="$x"; break ;}; done
  162. # Configure msmtprc for sending mail.
  163. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  164. echo "$msmtp_profile" >> "$msmtprc"
  165. # On Ubuntu/Debian, a link is needed since they use an older version.
  166. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  167. # Create the mbsync config file.
  168. mkdir -p "${mbsyncrc%/*}"
  169. echo "$mbsync_profile" >> "$mbsyncrc"
  170. # Create a muttrc for viewing mail.
  171. echo "$mutt_profile" > "$accdir/$idnum-$fulladdr.muttrc"
  172. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc"
  173. ! grep -q "^source.*mutt-wizard.muttrc" "$muttrc" && echo "source $mwconfig $MARKER" >> "$muttrc"
  174. ! grep "^source.*.muttrc" "$muttrc" | grep -qv "$mwconfig" && echo "source $accdir/$idnum-$fulladdr.muttrc $MARKER" >> "$muttrc"
  175. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$fulladdr.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" $MARKER" >> "$muttrc"
  176. notmuchauto # Create a notmuch config file if not present already.
  177. }
  178. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  179. fingerprint="$(msmtp --serverinfo --host=$smtp --port=$sport --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  180. sed -ibu "s/account $fulladdr/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu ;}
  181. getpass() { while : ; do pass rm -f "$pass_prefix$fulladdr" >/dev/null 2>&1
  182. pass insert "$pass_prefix$fulladdr" && break; done ;}
  183. formatShortcut() { toappend="$toappend
  184. macro index,pager g$1 \"<change-folder>=$3<enter>\" \"go to $2\" $MARKER
  185. macro index,pager M$1 \";<save-message>=$3<enter>\" \"move mail to $2\" $MARKER
  186. macro index,pager C$1 \";<copy-message>=$3<enter>\" \"copy mail to $2\" $MARKER" >> "$accdir/$idnum-$fulladdr.muttrc" ;}
  187. setBox() { toappend="$toappend
  188. set $1 = \"+$2\" $MARKER" ;}
  189. getboxes() { [ -n "${force+x}" ] && mailboxes="INBOX
  190. Drafts
  191. Junk
  192. Trash
  193. Sent
  194. Archive" && return 0
  195. if mailboxes="$(mbsync -l "$fulladdr" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  196. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $fulladdr-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  197. return 0
  198. else
  199. echo "$mailboxes"
  200. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  201. return 1
  202. fi ;}
  203. finalize() { echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$fulladdr/{}/cur" "$maildir/$fulladdr/{}/tmp" "$maildir/$fulladdr/{}/new"
  204. sed -ibu "/$MARKER/d" "$accdir/$idnum-$fulladdr.muttrc" ; rm -f "$accdir/$idnum-$fulladdr.muttrcbu"
  205. toappend="mailboxes $(echo "$mailboxes" | sed "s/^/\"=/;s/$/\"/" | paste -sd ' ' )"
  206. for x in $mailboxes; do
  207. case $x in
  208. *[Ii][Nn][Bb][Oo][Xx]*) formatShortcut i inbox "$x"; setBox spoolfile "$x" ;;
  209. *[Ss][Ee][Nn][Tt]*) setBox record "$x"; formatShortcut s sent "$x" ;;
  210. *[Dd][Rr][Aa][Ff][Tt][Ss]*) setBox postponed "$x"; formatShortcut d drafts "$x" ;;
  211. *[Tt][Rr][Aa][Ss][Hh]*) formatShortcut t trash "$x"; setBox trash "$x" ;;
  212. *[Jj][Uu][Nn][Kk]*) formatShortcut j junk "$x" ;;
  213. *[Aa][Rr][Cc][Hh][Ii][Vv][Ee]*) formatShortcut a archive "$x" ;;
  214. *[Ss][Pp][Aa][Mm]*) formatShortcut S spam "$x" ;;
  215. esac
  216. done
  217. echo "$toappend" >> "$accdir/$idnum-$fulladdr.muttrc"
  218. [ -z "${online+x}" ] && printf "\033[33mYou should now be able to run \`\033[32mmw -y %s\033[33m\` to begin to download your mail.\033[0m\\n" "$fulladdr"
  219. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  220. return 0 ;}
  221. syncwrapper() { mbsync "${1:--a}" &
  222. ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
  223. wait
  224. ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
  225. notmuch new ;}
  226. notmuchauto() { \
  227. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  228. [ -f "$NOTMUCH_CONFIG" ] && return 0
  229. nmbasic="[database]
  230. path=$maildir
  231. [user]
  232. name=$realname
  233. primary_email=$fulladdr
  234. [new]
  235. tags=unread;inbox;
  236. ignore=.mbsyncstate;.uidvalidity
  237. [search]
  238. exclude_tags=deleted;spam;
  239. [maildir]
  240. synchronize_flags=true
  241. [crypto]
  242. gpg_path=$GPG"
  243. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  244. setact() { if [ -n "${action+x}" ] && [ "$action" != "$1" ]; then
  245. echo "Running $1 with $action..."
  246. echo "Incompatible options given. Only one action may be specified per run."
  247. return 1
  248. else
  249. action="$1"
  250. fi; }
  251. trap 'echo -e "\033[0m\n"; exit' INT ABRT
  252. while getopts "fplhdYD:y:i:I:s:S:u:a:n:" o; do case "${o}" in
  253. l) setact list || exit 1 ;;
  254. d) setact delete || exit 1 ;;
  255. D) setact delete || exit 1 ; fulladdr="$OPTARG" ;;
  256. y) setact sync || exit 1 ; fulladdr="$OPTARG" ;;
  257. Y) setact sync || exit 1 ;;
  258. a) setact add || exit 1 ; fulladdr="$OPTARG" ;;
  259. i) setact add || exit 1 ; imap="$OPTARG" ;;
  260. I) setact add || exit 1 ; iport="$OPTARG" ;;
  261. s) setact add || exit 1 ; smtp="$OPTARG" ;;
  262. S) setact add || exit 1 ; sport="$OPTARG" ;;
  263. u) setact add || exit 1 ; login="$OPTARG" ;;
  264. n) setact add || exit 1 ; realname="$OPTARG" ;;
  265. m) setact add || exit 1 ; maxmes="$OPTARG" ;;
  266. o) setact add || exit 1 ; online=True ;;
  267. f) setact add || exit 1 ; force=True ;;
  268. p) echo "NOTE: Protonmail users must install and configure Protonmail Bridge first for the first sync to work."
  269. proton=True
  270. imap="127.0.0.1"
  271. iport="1143"
  272. smtp="127.0.0.1"
  273. sport="1025"
  274. ssltype="None"
  275. protonfinger
  276. setact add || exit 1
  277. ;;
  278. *) cat << EOF
  279. mw: mutt-wizard, auto-configure email accounts for mutt
  280. including downloadable mail with \`isync\`.
  281. Main actions:
  282. -a your@email.com Add an email address
  283. -l List email addresses configured
  284. -d Remove an already added address
  285. -D your@email.com Force remove account without confirmation
  286. -y your@email.com Sync mail for account by name
  287. -Y Sync mail for all accounts
  288. Options allowed with -a:
  289. -u Account login name if not full address.
  290. -n "Real name" to be on the email account.
  291. -i IMAP server address
  292. -I IMAP server port
  293. -s SMTP server address
  294. -S SMTP server port
  295. -p Install for a Protonmail account.
  296. -o Configure address, but keep mail online.
  297. -b Assume typical English mailboxes without attempting log-on.
  298. NOTE: Once at least one account is added, you can run
  299. \`mbsync -a\` to begin downloading mail.
  300. To chane an account's password, run \`pass edit ${pass_prefix}your@email.com\`.
  301. EOF
  302. exit 1
  303. ;;
  304. esac done
  305. ! command -v mbsync >/dev/null && [ -z "${force+x}" ] && printf "\`mbsync (isync package)\` must be installed to run mutt-wizard.\\n" && exit
  306. case "$action" in
  307. list) list ;;
  308. add) askinfo && getprofiles && writeinfo && getboxes && finalize || delete ;;
  309. delete) delete $fulladdr ;;
  310. sync) syncwrapper $fulladdr ;;
  311. esac